//TFC ETIS 1er Semestre curs 2011-2012
// Nom del Projecte: SSCF
//
// Consultor: Jordi Bécares Ferrés
// @author Jordi Carbonell Trilla
// Fitxer: Variables.h
//
// Definició de constatns i estructures dels missatges

#ifndef VARIABLES_H
#define VARIABLES_H

enum {
	MOTA_VAG1_ID		= 25, // identificador de la mota del vago número 1
	MOTA_VAG2_ID		= 26, // identificador de la mota del vago número 2
	MOTA_VAG3_ID		= 27, // identificador de la mota del vago número 3
	// ...

	AM_SENSORSMSG		= 40,
	AM_PORTAMSG			= 41,
	AM_ALARMMSG			= 42,
	AM_ESTACIOMSG		= 43
};


//Estructura del missatge que envia amb les dades
typedef nx_struct SensorsMsg {
	nx_uint8_t moteId;
	
	nx_uint16_t countsTemp;
	nx_uint16_t countsPhoto;
	nx_uint16_t countsBat;
	
	nx_uint16_t vrefmilivolts;
	
	nx_uint16_t counter;	
	
} SensorsMsg;


//Estructura del missatge que envia amb les dades
typedef nx_struct EstacioMsg {
	nx_uint8_t estacioId; // identificador de l'estació
	nx_bool hihadades;  // si hi ha dades 1 sinó 0
	nx_uint8_t datahora[6]; //dia,mes,any,hora,minut,segon
	nx_uint8_t cabinaId; // identificador de la cabina del comboi
	nx_uint8_t vagoId; // identificador del vagó	
	nx_uint16_t countsTemp;  // valor de temperatura
	nx_uint16_t countsPhoto; // valor de la il·luminació
	nx_uint16_t countsBat; // valor del voltatge de la corrent electrica
	nx_bool porta; // 1 si la porta és oberta 0 si és tancada
	nx_bool alarma; // 1 si s'ha premut l'alarma, 0 si no s'ha premut
	
	nx_uint16_t vrefmilivolts; // referència conversió voltatge
	
	nx_uint16_t counter; // comptador de paquets			
} EstacioMsg;



//Estructura del paquet d'obertura/tancament de portes
typedef nx_struct PortaMsg{
	nx_uint8_t moteId; // identificador del vagó
	nx_uint8_t seqNum; // 0 Vol dir porta tancada i 1 vol dir porta oberta

	nx_uint16_t countsTemp; // valor de temperatura
	nx_uint16_t countsPhoto; // valor de la il·luminació
	nx_uint16_t countsBat;	// valor del voltatge de la corrent electrica
	
	nx_uint16_t vrefmilivolts; // referència conversió voltatge		
}PortaMsg;


//Estructura del paquet que s'envia al premer el polsador de la mota
typedef nx_struct AlarmMsg{
	nx_uint8_t moteId; // identificador del vagó
	nx_uint8_t activat; // amb un 1 equival a polsador premut
	nx_uint16_t countsTemp; // valor de temperatura
	nx_uint16_t countsPhoto; // valor de la il·luminació
	nx_uint16_t countsBat;	// valor del voltatge de la corrent electrica
	
	nx_uint16_t vrefmilivolts; // referència conversió voltatge	
}AlarmMsg;


#endif /* VARIABLES_H */
