

import java.text.DecimalFormat;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.io.*;

import missatges.PortaMsg;
import missatges.AlarmMsg;
import missatges.SensorsMsg;
import missatges.EstacioMsg;


import net.tinyos.message.Message;
import net.tinyos.message.MessageListener;
import net.tinyos.message.MoteIF;
import net.tinyos.packet.BuildSource;
import net.tinyos.packet.PhoenixSource;
import net.tinyos.util.PrintStreamMessenger;


import java.sql.Connection;  
import java.sql.DriverManager;  
import java.sql.ResultSet;  
import java.sql.Statement;  


public class PC_CAB implements MessageListener{
	
	public static PC_CAB instancia = null; // instancia buida de PC_CAB 
	
	static MoteIF mif; // interficie per enviar/rebre missatges d'una mota
	static Finestra Finest=new Finestra(); // Mostra la finestra del programa
	static boolean porta=false; // desa l'última lectura de l'estat de la porta/// 0 tancada 1 oberta
	int llumi=0; // desa l'última lectura de la llum
	double tem=0; // desa l'última lectura de temperatura
	double volts=0;// desa l'última lectura de voltatge
	static int Motacab=4; // Identificador de la mota de la cabina	
	static boolean enviant=false; // marquem que estem enviat dades a la PC_EST
	static String bdconect="jdbc:firebirdsql://localhost:3050//BBDD/Info.fdb"; // Path de connexió de la BBDD
	
	static int LlumMinim=250; // Mímim de lux permesos

	
	//Classe principal
	public static void main (String args[]){
		
		Finestra.main(null); //Iniciem la pantalla gràfica				
		
		instancia = new PC_CAB();

		PhoenixSource phoenix; //interficie de connexió
		phoenix = BuildSource.makePhoenix(PrintStreamMessenger.err);
		phoenix = BuildSource.makePhoenix("sf@localhost:9002", PrintStreamMessenger.err); //cadena connexió
		
		PC_CAB.mif = new MoteIF(phoenix);		
		PC_CAB.mif.registerListener(new SensorsMsg(), instancia);
		PC_CAB.mif.registerListener(new PortaMsg(), instancia);
		PC_CAB.mif.registerListener(new AlarmMsg(), instancia);
		PC_CAB.mif.registerListener(new EstacioMsg(), instancia);		
	}//Final ...void main....

	
	//Això escurcem la funció per mostrar dades per pantalla
	//Salta de línia automàticament, no cal que ho forcem nosaltres amb el \n
	private static void println(String s){
		System.out.println(s);
	}


	//Quan rebem un missatge s'inica aquesta funció
	public void messageReceived(int to, Message m) {

		if(m instanceof SensorsMsg){
			SensorsMsg sm = (SensorsMsg) m;
			
			double lecturaVoltsBat = passarAVolts(sm.get_vrefmilivolts(),sm.get_countsBat())*2;	//4 es el factor d'atenuacio del divisor
			double lecturaVoltsTemp = passarAVolts(sm.get_vrefmilivolts(),sm.get_countsTemp());
			double temperaturaCentigrads = (lecturaVoltsTemp-0.5)/0.01;
			
			tem=roundTwoDecimals(temperaturaCentigrads);// emmagatzemem el valor de la temperatura
			llumi=sm.get_countsPhoto();// emmagatzemem la quantitat de llum						
			volts=roundTwoDecimals(lecturaVoltsBat); // emmagatzemem el valor del voltatge
			mostradades(Motacab, (int)sm.get_moteId(), tem, llumi, volts, porta, false);
			//int motacabid, int motavagid, float temp, int llum, float volt, boolean port, boolean alarma
		}
		else if(m instanceof PortaMsg){ // Obertura / Tancament Portes
			PortaMsg pm = (PortaMsg) m; 			
			
			double lecturaVoltsBat = passarAVolts(pm.get_vrefmilivolts(),pm.get_countsBat())*2;	//4 es el factor d'atenuacio del divisor
			double lecturaVoltsTemp = passarAVolts(pm.get_vrefmilivolts(),pm.get_countsTemp());
			double temperaturaCentigrads = (lecturaVoltsTemp-0.5)/0.01;			
			tem=roundTwoDecimals(temperaturaCentigrads);// emmagatzemem el valor de la temperatura
			llumi=pm.get_countsPhoto();// emmagatzemem la quantitat de llum						
			volts=roundTwoDecimals(lecturaVoltsBat); // emmagatzemem el valor del voltatge			
			
			if(pm.get_seqNum()==0){				
				mostradades(Motacab, (int)pm.get_moteId(), tem, llumi, volts, false, false);  // porta tancada
				porta=false;
			}else{				
				mostradades(Motacab, (int)pm.get_moteId(), tem, llumi, volts, true, false); // porta oberta
				porta=true;
			}						
		}
		else if(m instanceof AlarmMsg){  // Pulsat el botó d'alarma
			AlarmMsg am = (AlarmMsg) m;
			
			double lecturaVoltsBat = passarAVolts(am.get_vrefmilivolts(),am.get_countsBat())*2;	//4 es el factor d'atenuacio del divisor
			double lecturaVoltsTemp = passarAVolts(am.get_vrefmilivolts(),am.get_countsTemp());
			double temperaturaCentigrads = (lecturaVoltsTemp-0.5)/0.01;
			
			tem=roundTwoDecimals(temperaturaCentigrads);// emmagatzemem el valor de la temperatura
			llumi=am.get_countsPhoto();// emmagatzemem la quantitat de llum						
			volts=roundTwoDecimals(lecturaVoltsBat); // emmagatzemem el valor del voltatge			
			
			Finest.setMsgAlarm(am.get_moteId());// Si s'ha polsat el botó d'alarma, ho indiquem
			mostradades(Motacab, (int)am.get_moteId(), tem, llumi, volts, porta, true); // Alarma!!!!
		}
		else if(m instanceof EstacioMsg){  // Ens arriva un missatge tipus EstacioMsg
			EstacioMsg e = (EstacioMsg) m; 	
			
			if (e.get_counter()!=0) { // si el comptador és 0 és una sol·licitud de transmissió, sinó és l'acceptació d'un paquet				
				paquetOk(e.get_counter()); // al camp "counter" del paquet ens arriba la confirmació del missatge enviat								
			}else if(enviant==false){
				Finest.setMsgDades(e.get_estacioId()); // Marquem a la pantalla que enviem dades
				enviant=true; //Indiquem que comencem a enviar dades
				transDades(e.get_estacioId()); //Responem a la petició de dades.
		        enviant=false; //hem acabat d'enviar dades
			}
        	
			try {
	    		Thread.sleep(300); // fem una pausa de 300ms per evitar la salturació del buffer
	    		// És obligatori posar un try - catch
	    	} catch (InterruptedException ex) {}
	        Finest.getMsgDades(); // Marquem a la pantalla que ja no enviem dades
			
		}
		else{
			System.err.println("Sembla que s'ha rebut un missatge inesperat, l' amType és "+m.amType());
		}		
			
	} // Final ...void messageReceived
		
	
	// Voltatge de la Mota
	//Converteix del valor de referencia rebut a Volts
	private double passarAVolts(int vrefMilivolts, int counts){
		return (((double)counts)/1024)*(((double)vrefMilivolts)/1000);
	}	

	
	// Posar un doble de com a màxim 2 decimals
	double roundTwoDecimals(double d) {
        DecimalFormat twoDForm = new DecimalFormat("#,##");
        return Double.valueOf(twoDForm.format(d));
	}	
	
	
	// Posar la data i la hora en un arrai de char's
	static short[] formatejardatahora(String data, String hora) {
		short datahora[] = new short[6];
		datahora[0]=Short.valueOf((String)data.subSequence(5, 7));
		datahora[1]=Short.valueOf((String)data.subSequence(8, 10));
		datahora[2]=Short.valueOf((String)data.subSequence(2, 4));
		datahora[3]=Short.valueOf((String)hora.subSequence(0, 2));
		datahora[4]=Short.valueOf((String)hora.subSequence(3, 5));
		datahora[5]=Short.valueOf((String)hora.subSequence(6, 8));				
		return datahora;		
	}	

	
	//marquem el registre de la BBDD com a que s'ha enviat
	public static void paquetOk(int idRegistre){

		Connection connection = null;   
        Statement statement = null;  
        String consult="";
        try {  
            Class.forName("org.firebirdsql.jdbc.FBDriver");  
            connection = DriverManager.getConnection(bdconect, "sysdba", "masterkey");  
            connection.setAutoCommit(false);
            statement = connection.createStatement();            
                        
            //Marquem amb un 1 el camp ENVIAT del registre que ens passen per "idregistre"
            //per indicar que aquest paquet s'ha enviat correctament            
            consult="UPDATE PC_CAB SET ENVIAT='1' WHERE ID=" + idRegistre;            
            statement.executeUpdate(consult);            
            connection.commit();                                
        }catch (Exception e) {  
            e.printStackTrace();  
        }finally {  
            try {  
                statement.close();  
                connection.close();  
            }catch (Exception e) {  
                e.printStackTrace();  
            }  
        }					
	}// final public static void paquetOk
	
	
	// Enviar missatges a traves del port USB cap a la MOTA_CAB i d'aquí a la MOTA_EST
	public static void sendMessage(int destinatari, EstacioMsg mesg){
		try{
			mif.send(destinatari,mesg); // enviem l'identificador de l'estació i el missatge
		}catch(IOException e){
			println("No s'ha pogut enviar el missatge");
		}
	}

	
	
	//*************************************************************************************************
	//******************************** ENVIAR DADES A LA MOTA_EST   ***********************************	
	//*************************************************************************************************	
	//Enviem les dades pendents d'enviar que tenim a la BBDD de PC_CAB
	private static void transDades(short idEstacio){		

		Connection connection = null;  
        ResultSet resultSet = null;  
        Statement statement = null;  
		EstacioMsg mesg = new EstacioMsg();		
		int voltes=0;        
  
        try {  
            Class.forName("org.firebirdsql.jdbc.FBDriver");  
            connection = DriverManager.getConnection(bdconect, "sysdba", "masterkey");  
            
            statement = connection.createStatement();            
                        
            //Calculem l'index de la tupla (registre)
            resultSet = statement.executeQuery("SELECT * FROM PC_CAB WHERE ENVIAT=0");    
            
            resultSet.next();
            
            if (resultSet.getRow()==0){   //NO HI HA CAP DADA PER ENVIAR
            	mesg.set_estacioId(idEstacio); // posem el numero d'estació
            	mesg.set_cabinaId((short) Motacab); // posem el numero de comboi
            	mesg.set_hihadades((byte) 0); // marquem que no hi ha dades per transmetre
            	sendMessage(idEstacio,mesg); //enviem el paquet            	
            }
            else{ // ENVIEM LES DADES
	            do{
	            	mesg.set_hihadades((byte) 1); // marquem que hi ha dades per transmetre
	            	mesg.set_datahora(formatejardatahora(resultSet.getString("DATA"),resultSet.getString("HORA")));      ////dia,mes,any,hora,minut,segon	            	
	            	mesg.set_cabinaId(resultSet.getShort("MOTACABID")); // posem el numero de comboi
	            	mesg.set_vagoId(resultSet.getShort("MOTAVAGID")); // posem el numero de vagó
	            	mesg.set_countsTemp(resultSet.getInt("TEMP")); // introduim la temperatura
	            	mesg.set_countsPhoto(resultSet.getInt("LLUM")); // introduim la llum
	            	mesg.set_countsBat(resultSet.getInt("VOLT")); // introduim el voltatge
	            	mesg.set_porta(resultSet.getByte("PORTA")); // introduim si la porta està oberta o tancada
	            	mesg.set_alarma(resultSet.getByte("ALARMA")); // introduim l'alarma
	            	mesg.set_counter(resultSet.getInt("ID"));
	            	
	            	sendMessage(idEstacio,mesg); //enviem el paquet

	            	voltes++; // maxim de dades enviades a la vegada seran 5, sinó saturem la cua
	            }while (resultSet.next()  &&  voltes<5);	     	            	                	            
            }                        
        }catch (Exception e) {  
            e.printStackTrace();  
        }finally {  
            try {  
                resultSet.close();  
                statement.close();  
                connection.close();  
                mesg=null; // tanquem l'objecte
                enviant=false; //hem acabat d'enviar dades
            }catch (Exception e) {e.printStackTrace();}  
        }					
	}// final private static void transDades..........
		

	//*************************************************************************************************
	//******************************************  EMMAGATZEMAR   **************************************	
	//*************************************************************************************************	
	//Desem les dades que anem rebent
	private static void emmagatzemar(String data, String hora, int motacabid, int motavagid, double temp, int llum, double volt, boolean port, boolean alarma){
		
        Connection connection = null;  
        ResultSet resultSet = null;  
        Statement statement = null;  
        String consult="";
        long autocom=0;
        int sporta=0, salarma=0;
  
        try {  
            Class.forName("org.firebirdsql.jdbc.FBDriver");  
            connection = DriverManager.getConnection(bdconect, "sysdba", "masterkey");  
            connection.setAutoCommit(false);
            statement = connection.createStatement();
                                    
            //Calculem l'index de la tupla (registre)
            resultSet = statement.executeQuery("SELECT MAX(ID) AS ID FROM PC_CAB");                                              
            resultSet.next();
            if (resultSet.getLong("ID")!=0){            	
            	autocom= (long)resultSet.getLong("ID");
            	autocom++;
            }else{            	
            	autocom=1;
            }
            
            // Per la porta i l'alarma substituim el True o False per 1 o 0            
            if (port==false){sporta=0;}else{sporta=1;};
            if (alarma==false){salarma=0;}else{salarma=1;};
                             
            // afegit per mi no val aquest codi, només serveis per afegir un registre més amb l'hora acutal
            consult="INSERT INTO PC_CAB (ID, ENVIAT, DATA, HORA, MOTACABID, MOTAVAGID, TEMP, LLUM, VOLT, PORTA, ALARMA) "
            		+ "VALUES ('"+ autocom +"','0', '"+ data +"','"+ hora +"','"+ motacabid +"','"+ motavagid +"','"
            		+ temp + "','"+ llum +"','"+ volt +"','"+ sporta +"','"+ salarma +"')";
            statement.executeUpdate(consult);
            connection.commit();
            
            resultSet = statement.executeQuery("SELECT * FROM PC_CAB");                        
            
        } catch (Exception e) {  
            e.printStackTrace();  
        } finally {  
            try {  
                resultSet.close();  
                statement.close();  
                connection.close();  
            } catch (Exception e) {e.printStackTrace();}  
        }							
	} // final private static void emmagatzemar...
	
	
	//*************************************************************************************************
	//********************************* ACTUALITZACIÓ DE  PANTALLA   **********************************	
	//*************************************************************************************************		
	// Cada línia de dades que arriva la mostrem
	private static void mostradades(int motacabid, int motavagid, double temp, int llum, double volt, boolean port, boolean alarma){

		String data;
		String hora;
		String MotaVagId=Integer.toString(motavagid);
		
		//Agafem la data i la hora del sistema
        Date datahora = new Date();
        SimpleDateFormat formato = new SimpleDateFormat("MMddyyyy H:mm:ss");
        String DataAvui = formato.format(datahora);	
                
        int mig = DataAvui.indexOf(" ");        
        data=DataAvui.substring(0, 2)+"/";
        data=data+DataAvui.substring(2, 4)+"/";
        data=data+DataAvui.substring(4, mig);
        hora=DataAvui.substring(mig, DataAvui.length());
		
		//DESEM LES DADES A LA BASE DE DADES
		emmagatzemar(data, hora, motacabid, motavagid, temp, llum, volt, port, alarma);
		////////////
		
		// Actualitzem la taula de dades de la cabina del conductor
		Finest.getTable().getModel().setValueAt(MotaVagId, 1, 0); // ID Vagó
		Finest.getTable().getModel().setValueAt(hora, 1, 1); // Hora
		Finest.getTable().getModel().setValueAt(temp, 1, 2); // Temperatura
		if(llum>LlumMinim){
			Finest.getTable().getModel().setValueAt("CORRECTE", 1, 3);
		}else{
			if ((!alarma) && (port==porta)) Finest.setMsgIlum(motavagid);// Si hi ha un error en la il·luminació, mostrem un missatge d'error
			Finest.getTable().getModel().setValueAt("ERROR", 1, 3);			
		}; // Llum		
		
		if (port){ //Si està oberta la porta
			Finest.getTable().getModel().setValueAt("OBERTA", 1, 4); // Porta
		}else{ // Si està tancada
			Finest.getTable().getModel().setValueAt("TANCADA", 1, 4); // Porta
		}

		if (alarma){ //Si s'ha polsat el botó d'alarma
			Finest.getTable().getModel().setValueAt("ALARMA", 1, 5); // Alarma
		}else{ // Si està tancada
			Finest.getTable().getModel().setValueAt(" ", 1, 5); // Alarma
		}							
	}	// infal private static void mostradades ...........

	
}// Final class PC_CAB
