
import java.text.DecimalFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.io.*;

import missatges.EstacioMsg;

import net.tinyos.message.Message;
import net.tinyos.message.MessageListener;
import net.tinyos.message.MoteIF;
import net.tinyos.packet.BuildSource;
import net.tinyos.packet.PhoenixSource;
import net.tinyos.util.PrintStreamMessenger;

//package com.javaworkspace.connectfirebirddb;  

import java.sql.Connection;  
import java.sql.DriverManager;  
import java.sql.ResultSet;  
import java.sql.Statement;  


public class PC_EST implements MessageListener{
	
	public static PC_EST instancia = null; // instancia buida de PC_CAB 
	static MoteIF mif; // interficie per enviar/rebre missatges d'una mota
	static Finestra Finest=new Finestra();  // Mostra la finestra del programa
	boolean porta=false; // desa l'última lectura de l'estat de la porta/// 0 tancada 1 oberta
	int llumi=0; // desa l'última lectura de la llum
	double tem=0; // desa l'última lectura de temperatura
	double volts=0;// desa l'última lectura de voltatge
	static int MotaEst=127; // Identificador de la mota de l'estació
	static boolean paraDescobridor=false; // Quan una mota ens envia una confirmació parem el descobridor
	static String bdconect="jdbc:firebirdsql://localhost:3050//BBDD/Info.fdb"; // Path de connexió de la BBDD
	
	static int LlumMinim=250; // Mímim de lux permesos
	static int lapset=2000; //Temps d'espera en mili segons

	static ArrayList<Integer> confirm = new ArrayList <Integer>();
	
	//Classe principal
	public static void main (String args[]){

		Finestra.main(null); //Iniciem la pantalla gràfica

		confirm.clear(); //netejem la confirmació de missatges
		
		instancia = new PC_EST();

		PhoenixSource phoenix; //interficie de connexi�
		phoenix = BuildSource.makePhoenix(PrintStreamMessenger.err);
		phoenix = BuildSource.makePhoenix("sf@localhost:9004", PrintStreamMessenger.err); //cadena connexió
		
		PC_EST.mif = new MoteIF(phoenix);		
		PC_EST.mif.registerListener(new EstacioMsg(), instancia);	

		// Bucle infinit que anem enviant dades 
		do{
			try {
	    		Thread.sleep(lapset); // fem una pausa de x segons per no saturar les cues de les motes	    		
	    	} catch (InterruptedException ex) {} // És obligatori posar un try - catch
	    			    	
	    	//si alguna MOTA_CAB ens detecta parem 
			if(!paraDescobridor){ descobridor((short)MotaEst);}									
		}while(1<2); // Bucle infinit		
	}//Final ...void main....

	
	//Això escurcem la funció per mostrar dades per pantalla
	//Salta de línia automàticament, no cal que ho forcem nosaltres amb el \n
	private static void println(String s){
		System.out.println(s);
	}

	
	//Quan rebem un missatge s'inica aquesta funció
	public void messageReceived(int to, Message m) {
		paraDescobridor=true;
	
		if(m instanceof EstacioMsg){// Ens arriva un missatge tipus EstacioMSG
			EstacioMsg e = (EstacioMsg) m; 			

			if (e.get_hihadades()!=0) { // si no hi ha dades no fem res (0 no hi ha dades; 1 hi ha dades)
				Finest.setMsgDades(e.get_cabinaId()); // Indiquem que rebem dades d'un comboi
				emmagatzemar(e); //Si hi ha dades emmagatzemem la informació									
			}else{
				Finest.setMsgDades(e.get_cabinaId()); // Indiquem que rebem dades d'un comboi
				println("No hi ha més dades per rebre");    			    						
			}
		}
		else{
			System.err.println("Sembla que s'ha rebut un missatge inesperat, el amType es "+m.amType());
		}	

		paraDescobridor=false;
		
		try {
    		Thread.sleep(100); // fem una pausa de 100ms per evitar la salturació del buffer    		
    	}catch (InterruptedException ex) {}	// És obligatori posar un try - catch
		
		Finest.getMsgDades(); // treiem el missatge de s'estan rebent dades			
	} // Final ...void messageReceived
	
		
	// Posar un doble de com a màxim 2 decimals
	double roundTwoDecimals(double d) {
        DecimalFormat twoDForm = new DecimalFormat("#,##");
        return Double.valueOf(twoDForm.format(d));
	}	
	
	
	// Extreure la Data d'un arrai de Char's en format (MMddaaaa)
	static String formatejardata(short[] data) {
		String datasort="";
		datasort= String.valueOf(data[0]) + "/" + String.valueOf(data[1])+"/20" + String.valueOf(data[2]);
		return datasort;		
	}	

	
	// Extreure la Data d'un arrai de Char's en format (MMddaaaa)
	static String formatejarhora(short[] hora) {
		String horasort="";
		horasort= String.valueOf(hora[3]) + ":" + String.valueOf(hora[4])+":" + String.valueOf(hora[5]);
		return horasort;		
	}	
	
	
	//Funció que envia un missatge per detectar possibles MOTA_CAB
	//només posem l'ID de l'estació i deixem tots els altres camps en blanc
	public static void descobridor(short idEstacio){
		EstacioMsg mesg = new EstacioMsg();	
		mesg.set_estacioId(idEstacio); // posem el numero d'estació
		mesg.set_counter(0); // indiquem que el missatge és un descobridor de mote's

		sendMessage(65535,mesg); // enviem el paquet a tothom (65535)
		mesg=null; // eliminem l'objecte
	}
	

	// Enviar missatges a traves del port USB cap a la MOTA_CAB
	public static void sendMessage(int destinatari, EstacioMsg mesg){		
		try{
			mif.send(destinatari,mesg); // enviem l'identificador de l'estació i el missatge a tothom (broadcast)			
		}catch(IOException e){
			println("No s'ha pogut enviar el missatge");
		} 		
	}

	
	// Comprova que el missatge no estigui repetit
	//True--> està repetit      FALSE--> No està repetit
	public static boolean repMessage(EstacioMsg eM){		
		boolean repetit=false;
		int compt=1;
		
		if (confirm.size()!=0 && confirm.get(0)==eM.get_cabinaId()){ // si és el mateix tren comprome que haguessim rebut el missatge
				
			while(compt<confirm.size()  &&  repetit==false){
				if(confirm.get(compt)==eM.get_counter()){ // si ja el tenim introduit es que s'ha repetit
					repetit=true;
				}	
				compt++;
			}			
			if (!repetit) {confirm.add(eM.get_counter());}; // Afegim que hem rebut el missatge amb l'identificador x si no està repetit
		}
		else{ // si és un tren diferent o un paquet erroni
			if(eM.get_cabinaId()!=0){ // Si el paquet no és erroni és que ha arribat un altre comboi
				confirm.clear();
				confirm.add((int)eM.get_cabinaId()); // Afegim l'identificador a la primera posició
				confirm.add(eM.get_counter()); // Afegim que hem rebut el missatge amb l'identificador 
			}else{
				repetit=true; // paquet erroni
			}
		}						
		return repetit;
	}	
	
		

	//*************************************************************************************************
	//******************************************  EMMAGATZEMAR   **************************************	
	//*************************************************************************************************	
	//Desem les dades que anem rebent
	private static void emmagatzemar(EstacioMsg M){

		//String data, String hora, int motacabid, int motavagid, double temp, int llum, 
		//double volt, boolean port, boolean alarma)
		
		EstacioMsg eM = (EstacioMsg) M.clone();
		
		if(!repMessage(eM)){ // Comprovem si el missage rebut ja està introduit o és erroni
		
		    Connection connection = null;  
		    ResultSet resultSet = null;  
		    Statement statement = null;  
		    String consult="";
		    long autocom=0;             
			String data="";
			String hora="";
			
			String MotaEstId=Integer.toString(MotaEst);
			
			//Agafem la data i la hora del sistema
		    Date datahora = new Date();
		    SimpleDateFormat formato = new SimpleDateFormat("MMddyyyy H:mm:ss");
		    String DataAvui = formato.format(datahora);	
		            
		    int mig = DataAvui.indexOf(" ");        
		    data=DataAvui.substring(0, 2)+"/";
		    data=data+DataAvui.substring(2, 4)+"/";
		        data=data+DataAvui.substring(4, mig);
		        hora=DataAvui.substring(mig+1, DataAvui.length());                
		  
		        try {  
		            Class.forName("org.firebirdsql.jdbc.FBDriver");  
		        connection = DriverManager.getConnection(bdconect, "sysdba", "masterkey");  
		        connection.setAutoCommit(false);
		        statement = connection.createStatement();            
		                    
		        //Calculem l'index de la tupla (registre)
		        resultSet = statement.executeQuery("SELECT MAX(ID) AS ID FROM PC_EST");
		        resultSet.next();
		        if (resultSet.getLong("ID")!=0){            	
		        	autocom= (long)resultSet.getLong("ID");
		        	autocom++;
		        }else{            	
		        	autocom=1;
		        }                       
		                    
		         // afegit per mi no val aquest codi, només serveis per afegir un registre més amb l'hora acutal
		        consult="INSERT INTO PC_EST (ID, ENVIAT, DATAEST, HORAEST, MOTAESTID, DATA, HORA, MOTACABID, MOTAVAGID, " +
		        		"TEMP, LLUM, VOLT, PORTA, ALARMA) " +
		        		"VALUES ('"+ autocom +"','0', '"+ data +"','"+ hora +"','"+ MotaEstId +"','"+ formatejardata(eM.get_datahora()) +"','"+ formatejarhora(eM.get_datahora()) 
		        		+"','"+ eM.get_cabinaId() +"','"+ eM.get_vagoId() +"','"+ eM.get_countsTemp() +"','"+ eM.get_countsPhoto() 
		        		+"','"+ eM.get_countsBat() +"','"+ eM.get_porta() +"','"+ eM.get_alarma() +"')"; 
		        
		        statement.executeUpdate(consult);
		        connection.commit(); // apliquem el canvi a la BBDD
		        
		        // Enviem la confirmació de la recepció de missatge a la MOTA_CAB              
		        sendMessage(eM.get_cabinaId(),eM);
		        
		        //Actualitzem les dades que apareixen a la pantalla gràfica
		        mostraDades(eM);
		       
		    }catch (Exception e) {  
		        e.printStackTrace();  
		    }finally {  
		        try {  
		            resultSet.close();  
		            statement.close();  
		            connection.close();  
		            eM=null; // eliminem l'objecte
		        }catch (Exception e) {e.printStackTrace();}  
		    }				

		}else{
            // Enviem la confirmació de la recepció de missatge a la MOTA_CAB              
            if(eM.get_cabinaId()!=0){sendMessage(eM.get_cabinaId(),eM);}; //Si el paquet no és erroni enviem la confirmació        
		}// final de:  if(!repMessage(eM)){ 		
	} // final private static void emmagatzemar.....

	
	
//*************************************************************************************************
//********************************************  PANTALLA   ****************************************	
//*************************************************************************************************		
	private static void mostraDades(EstacioMsg eM){

		int motacabid=eM.get_cabinaId();
		
		String hora=formatejarhora(eM.get_datahora());
		String MotaVagId=Integer.toString(eM.get_vagoId());
		double temp=eM.get_countsTemp();
		int llum=eM.get_countsPhoto();

		boolean port=false;
		boolean alarma=false;		
        if (eM.get_porta()==0){port=false;}else{port=true;};
        if (eM.get_alarma()==0){alarma=false;}else{alarma=true;};

        Finest.setComboi(Integer.toString(motacabid)); // Posem l'identificador del comboi que hi ha a l'estaci�

        // Actualitzem la taula de dades de la cabina del conductor
		Finest.getTable().getModel().setValueAt(MotaVagId, 1, 0); // ID Vagó
		Finest.getTable().getModel().setValueAt(hora, 1, 1); // Hora
		Finest.getTable().getModel().setValueAt(temp, 1, 2); // Temperatura

		if(llum>LlumMinim){ // si la lluminositat està per sobre del mínim marcat
			Finest.getTable().getModel().setValueAt("CORRECTE", 1, 3);
		}else{
			// Si hi ha un error en la il·luminació, mostrem un missatge d'error		
			Finest.getTable().getModel().setValueAt("ERROR", 1, 3);			
		}; // Llum

		if (port){ //Si està oberta la porta
			Finest.getTable().getModel().setValueAt("OBERTA", 1, 4); // Porta
		}else{ // Si està tancada
			Finest.getTable().getModel().setValueAt("TANCADA", 1, 4); // Porta
		}; //porta		

		if (alarma){ //Si s'ha polsat el botó d'alarma
			Finest.getTable().getModel().setValueAt("ALARMA", 1, 5); // Alarma
		}else{ // Si està tancada
			Finest.getTable().getModel().setValueAt(" ", 1, 5); // Alarma
		}; // alarma						
	}	// final private static void mostraDades....
	
}// Final class PC_CAB
